#ifndef CONFIGBITS_H
#define CONFIGBITS_H

/**
	@author Alain Gibaud (free.fr) <alain.gibaud@free.fr>
	Represents the complete  set of config registers
	for a given device
*/

#include "pikdb.hh"
#include "ConfigBitsWord.h"
#include <qvector.h>
#include "CCodeGenerator.h"

class ConfigBits : public CCodeGenerator
{
	public:
		ConfigBits ( deviceRecord * deviceData );

		~ConfigBits();
		void dump ( ostream& os ) ;
		Q3ValueVector<ConfigBitsWord>& theWords() { return words ; }
		friend ostream& operator<< ( ostream& out, const ConfigBits& cb ) ;
		const char * setRawValues ( const Q3ValueVector<int>& values );
		Q3ValueVector<int> getRawValues() ;
		void writeCCode ( const QString& directory );
		QString makeCCode( ) ;
		void writeASMCode ( const QString& directory ) ;
		QString makeASMCode ( )	;
		QString makeCode(int selector) ;
private:
		Q3ValueVector<ConfigBitsWord> words ;
		deviceRecord *device ;

};

#endif
