#ifndef CONFIGBITSWIZARD_H
#define CONFIGBITSWIZARD_H

#include <QMainWindow>
#include <q3listview.h>
//Added by qt3to4:
#include <Q3PopupMenu>
#include <Q3MainWindow>

class ConfigBits ;
class Project ;
class ProjectWid ;
class deviceRecord ;

/**
	A widget for generation of config bits code source (C and ASM)

	@author Alain Gibaud (free.fr) <alain.gibaud@free.fr>
*/
class ConfigBitsWizard : public Q3MainWindow
{
Q_OBJECT
public:
    ConfigBitsWizard(ProjectWid *parent);
    ~ConfigBitsWizard();
    virtual void   closeEvent(QCloseEvent *event) ;
     
private:
	deviceRecord * deviceData ;
	// DeviceRecord *target_device ;
	Project *current_project ;

	Q3ListView  *confView ;
	Q3PopupMenu *makePopup ( const QString& txt, QWidget *parent ) ;
	ConfigBits *config;
protected:
        virtual bool   queryClose () ;

private slots:
	void slotRButton ( Q3ListViewItem *, const QPoint &, int ) ;
	void slotWriteConfig() ;
	void slotReadConfig();
        void slotMakeCode();
public slots:
       void slotClose();
signals:
       void closed() ;
};

#endif
