/***************************************************************************
                          ProjectWid.cpp  -  description
                             -------------------
    begin                : sam jui 5 2003
    copyright            : (C) 2003 by Alain Gibaud
    email                : alain.gibaud@univ-valenciennes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ProjectWid.h"
#include <QStringList>
#include <q3vbox.h>
#include <q3hbox.h>
#include <QPushButton>
#include <q3popupmenu.h>
#include <QLabel>
#include <QColor>
#include <QDir>
#include <QMessageBox>
#include <q3url.h>
#include <QApplication>
#include <q3dragobject.h>
#include <qglobal.h>
#include <QToolTip>
//Added by qt3to4:
#include <QPixmap>
#include <Q3Frame>
#include <QDragEnterEvent>
#include <QDropEvent>
#include <QFileDialog>

#include <iostream>
#include <assert.h>
using namespace std ;

#include "NewProject.h"
#include "ProjectEditorWid.h"
#include "FNU.h"
#include "PikMain.h"
#include "ConfigBitsWizard.h"

#include "XQListviewitem.h"

#include "codeanalyzer.h"
#include "parser.h"
#include "codeeditor/QBEditor.h"
#include "RecentItemsAction.h"

#include "project.xpm.h"
#include "sourcefile.xpm.h"
#include "includefile.xpm.h"
#include "csourcefile.xpm.h"
#include "objectfile.xpm.h"
// icons for asm entry points
#include "entrypointA_slb.xpm.h"
// icons for C entry points
#include "entrypointDataDecl.xpm.h"
#include "entrypointDataDef.xpm.h"
#include "entrypointFctDecl.xpm.h"
#include "entrypointFctDef.xpm.h"
#include "entrypointTypename.xpm.h"

#include <iostream>
using namespace std ;

ProjectWid::ProjectWid ( PikMain *mainwin, QWidget *parent, const char *name )
		: Q3VBox ( parent,name ),
		newproject ( 0 ),
		currentListViewItem ( 0 ),
		project ( 0 ),
		main_window ( mainwin ),
		projecteditor ( 0 ),
		configbits_editor ( 0 ),
		entryPointTimer ( 0 )
{

	projView =    new  Q3ListView ( this ) ;
        int firstcol = projView->addColumn ( tr ( "Files" ),170 ) ;
	projView->setColumnWidthMode ( firstcol,Q3ListView::Manual ) ;
	// projView->setColumnWidthMode (0, QListView::Maximum  );

        projView->addColumn ( tr ( "Info" ), 170 ) ;
	projView->setRootIsDecorated ( true ) ;

	projView->setShowToolTips ( true ) ;

        projectTree  =   new Q3ListViewItem ( projView, tr ( "  <Empty>  " ),"","p" ) ;
	projectTree->setPixmap ( 0, QPixmap ( ( const char** ) project_xpm ) ) ;

	connect ( projView    , SIGNAL ( rightButtonPressed ( Q3ListViewItem *, const QPoint &, int ) ),
	          this, SLOT ( slotProjectRButton ( Q3ListViewItem *, const QPoint &, int ) ) ) ;

	connect ( projView    , SIGNAL ( clicked ( Q3ListViewItem * ) ), this,
	          SLOT ( slotProjectElementClicked ( Q3ListViewItem * ) ) ) ;

        entryPointTimer = new QTimer ( this ) ;
        connect ( entryPointTimer , SIGNAL ( timeout() ) , this, SLOT ( slotUpdateEntryPoints() ) ) ;
        entryPointTimer->start ( 5000, false ) ; // start and reschedule timert

	slotProjectIsOpen ( false ) ;
	setAcceptDrops ( true ) ;


}


ProjectWid::~ProjectWid()
{
}

void  ProjectWid::slotProjectRButton ( Q3ListViewItem *li , const QPoint &p , int )
{


    QIcon iconopenproject ( ":/src/icons/22/pikdev_openproject.png" ) ;
    QIcon iconnewproject  ( ":/src/icons/22/pikdev_createproject.png" ) ;
    QIcon iconeditproject ( ":/src/icons/22/pikdev_editproject.png" ) ;
    QIcon iconcloseproject ( ":/src/icons/22/pikdev_closeproject.png" ) ;
    QIcon iconaddfile ( ":/src/icons/22/pikdev_addfile.png" ) ;
    QIcon iconaddcurrentfile ( ":/src/icons/22/pikdev_addcurrentfile.png" ) ;
    QIcon iconbiteditor ( ":/src/icons/22/pikdev_edit_cfbits.png" ) ;

	
	QString menu_title ;

	currentListViewItem = li ;
	if ( li != 0 )
	{
		if ( li->text ( 2 )  == "P" )
		{
			// "open" project entry
                        QMenu *pop = makePopup ( tr ( "Project" ), this ) ;
                        pop->addAction("Project")->setEnabled(false);
                        pop->addSeparator() ;
                        QAction *a1 = pop->addAction ( iconaddfile, tr ( "Insert file" )  ) ;
                        QAction *a2 = pop->addAction ( iconaddcurrentfile,  tr ( "Insert current file" )  ) ;
                        QAction *a3 = pop->addAction ( iconeditproject, tr ( "Edit project" )  ) ;
                        QAction *a4 = pop->addAction ( iconcloseproject, tr ( "Close project" )  ) ;
                        QAction *a5 = 0 ;
			if ( project )
			{
				pop->insertSeparator() ;
                                a5 = pop->addAction ( iconbiteditor , tr ( "Edit device configuration bits" )  ) ;
			}

                        QAction *a = pop->exec ( p ) ;

                        if( a == a1) slotInsertFile() ;
                        else if ( a == a2 ) slotInsertCurrentFile() ;
                        else if ( a == a3 ) slotEditProject() ;
                        else if ( a == a4 ) slotCloseProject() ;
                        else if (a == a5) slotEditConfigBits() ;

		}
		else if ( li->text ( 2 )  == "p" )
		{
                    // empty project entry

                    QMenu *pop = makePopup ( tr ( "Project" ), this ) ;
                    QAction *a1 = pop->addAction ( iconnewproject, tr ( "Create project" )  ) ;
                    QAction *a2 = pop->addAction ( iconopenproject, tr ( "Open project" )  ) ;

                    QAction *a = pop->exec ( p ) ;
                    if ( a == a1 && newproject == 0 )
                    {
                        slotNewProject() ;
                    }
                    else if ( a == a2 && newproject == 0 )
                    {
                        slotOpenProject() ;
                    }
		}
		else
		{
			QString code =  li->text ( 2 )  ;
			if ( code != "CE" && code != "RE" )
			{
                                if ( code  == "A" ||  code  == "C" )  menu_title =  tr ( "Source file" ) ;
                                else if ( code  == "O" )  menu_title = tr ( "Object file" ) ;
                                else if ( code  == "L" )  menu_title = tr ( "Library file" ) ;
                                else if ( code  == "I" )  menu_title =  tr ( "Include file" );
                                else if ( code  == "S" )  menu_title =  tr ( "Linker script file" );
                                else if ( code  == "R" )  menu_title =  tr ( "Source library file" );
                                else  menu_title =  tr ( "Other file" )  ;
				//
                                QMenu *pop = makePopup ( menu_title , this ) ;
                                QAction *a1 = pop->addAction (QIcon() , tr (  "Remove from project" ) ) ;

                                QAction *a = pop->exec ( p ) ;
                                if ( a == a1 )
				{
					slotRemoveFile() ;
				}
			}
		}
	}
}

/** No descriptions */
void ProjectWid::slotCreateProject ( const QString& projectname,
                                     const QString& projectdir,
                                     const QString& projecttype )

{
	QDir dir ;
	// multiple project files in one directory are now allowed

	QString projfile ( projectdir + "/" + projectname + ".pikprj" ) ;
	QFile f ( projfile ) ;
	// reject request if project file already exists
	if ( f.exists() )
	{
                QMessageBox::critical ( this,tr ( "Sorry" ),
                                        tr ( "The project file <b>%1</b> already exists" ).arg ( projfile ) ,
		                        QMessageBox::Ok, Qt::NoButton, Qt::NoButton ) ;
		return ;
	}

	// create dir if it does not exist
	if ( !dir.exists ( projectdir ) && !dir.mkdir ( projectdir ) )
	{
                QMessageBox::critical ( this,tr ( "Sorry" ),
                                        tr ( "Cannot create directory <b>%1</b>" ).arg ( projectdir ) ,
		                        QMessageBox::Ok, Qt::NoButton, Qt::NoButton ) ;
		return ;
	}

	if ( project ) delete project ;

	project = new Project ( projfile ) ;
	// set minimal project data
	project->setDescription ( "" ) ;
	project->setOutput ( projectname+".hex" ) ;
	project->setVersion ( "0.1" ) ;
	project->setType ( projecttype ) ;
	project->commit() ;

	projectTree->setText ( 2,"P" ) ; // change status to "open project"
	if ( projecttype == "asm" )
                projectTree->setText ( 1, tr ( "Asm project" ) ) ;
	else if ( projecttype == "C" )
                projectTree->setText ( 1, tr ( "C project" ) ) ;

	// cout << "projecttype = " <<  projecttype << endl ;

	projectTree->setText ( 0, projfile ) ; // change label to file name
	slotProjectIsOpen ( true ) ;

}
/** No descriptions */
void ProjectWid::slotNewProjectClosed()
{
	newproject = 0 ;
}
/** No descriptions */
void ProjectWid::slotCloseProject()
{
	if ( project )
	{
		// signals will reset pointers
		if ( projecteditor )
		{
			projecteditor->close ( true ) ; 
		}
		if( configbits_editor )
		{
			configbits_editor->close(true) ; 
		}
		projectTree->setText ( 2,"p" ) ; // change status to "closed project"
		projectTree->setText ( 1,"" ) ;
                projectTree->setText ( 0,tr ( "  <Empty>  " ) ) ;

		for ( Q3ListViewItem * it = projectTree->firstChild();  it ; )
		{
/*
			// close editor for this file (if open)
			QString absfilename = project->absFilename ( it->text ( 0 ) ) ;
			if ( main_window->editorManager()  && main_window->editorManager()->switchToEditor ( absfilename ) != 0 )
			{
				// editor found and set current : close it
				main_window->editorManager()->removeCurrentEditor() ;
			}
*/
			Q3ListViewItem *it1 = it ;
			it = it->nextSibling();
			delete it1 ;
		}
		// close ALL open files !!
                main_window->editor()->slotCloseAllDocuments() ;

		slotProjectIsOpen ( false ) ;
		delete project ;
		project = 0 ;
	}
}
/** Display file selector and insert a new File to project */
void ProjectWid::slotInsertFile()
{
	if ( project == 0 ) return ; // security

        QString filename = QFileDialog::getOpenFileName(this, tr ( "Select file" ), ".",
                                                        tr("Asm source (*.src *.slb *.asm *.SRC *.SLB *.ASM);;"
                                                           "C source (*.c *.C);;"
                                                           "C header (*.h *.H);;"
                                                           "Object file (*.o *.O);;"
                                                           "Library (*.slb *.lib *.a);;"
                                                           "Asm include file (*.inc *.INC);;"
                                                           "Linker script (*.lkr *.LKR)"), 0)  ;

	if ( filename != "" )  insertAbsFile ( filename ) ;
}

bool ProjectWid::insertAbsFile ( const QString &fname )
{
	if ( project->absFileExists ( fname ) ) return false ; // already exists
	QString f = project->projectRelative ( fname ) ; // make filename project relative
	project->addFile ( f ) ;
	addFile2Tree ( f ) ;
	return true ;
}

/** No descriptions */
void ProjectWid::slotOpenProject()
{
	if ( newproject != 0 ) newproject->close ( true ) ;
	if ( project != 0 ) slotCloseProject() ; // security

        QString projectfile = QFileDialog::getOpenFileName(this, tr ( "Select project file" ), ".",
                                                           tr("Pikdev project file (*.pikprj *.PIKPRJ" ), 0)  ;

	slotOpenProjectFile ( projectfile ) ;
}
/** Add a file name to the project tree
filename may be :
a) absolute
b) relative to the project file location
 */
void ProjectWid::addFile2Tree ( const QString& f )
{
	// QString ex = FNU::ext(f) ;
	char **icon = ( char ** ) sourcefile_xpm;
	QString type, code ;

	if ( FNU::isAsmSource ( f ) )
	{
		icon = ( char ** ) sourcefile_xpm ;
                type =  tr ( "ASM file" )  ;
		code =  "A"    ;
	}
	if ( FNU::isIncFile ( f ) )
	{
		icon = ( char ** ) includefile_xpm ;
                type =  tr ( "Include file" ) ;
		code =  "I"    ;
	}
	else if ( FNU::isCSource ( f ) )
	{
		icon = ( char ** ) csourcefile_xpm ;
                type =  tr ( "C file" )  ;
		code =  "C"    ;
	}
	else if ( FNU::isCHeader ( f ) )
	{
		icon = ( char ** ) includefile_xpm ;
                type =  tr ( "C header" )  ;
		code =  "H"    ;
	}
	else if ( FNU::isSrcLib ( f ) )
	{
		icon = ( char ** ) objectfile_xpm ;
                type =  tr ( "Source Lib" )  ;
		code =  "R"    ;
	}
	else if ( FNU::isObjFile ( f ) )
	{
		icon = ( char ** ) objectfile_xpm ;
                type =  tr ( "Object file" )  ;
		code =  "O"    ;
	}
	else if ( FNU::isLibFile ( f ) )
	{
		icon = ( char ** ) objectfile_xpm ;
                type =  tr ( "Library file" )  ;
		code =  "L"    ;
	}
	else if ( FNU::isLnkScrFile ( f ) )
	{
		icon = ( char ** ) sourcefile_xpm ;
                type =  tr ( "Linker script file" )  ;
		code =  "S"    ;
	}

	Q3ListViewItem *entry = new Q3ListViewItem ( projectTree,f, type,code ) ;
	entry->setPixmap ( 0, QPixmap ( ( const char** ) icon ) ) ;
	// open tree
	projectTree->setOpen ( true ) ;

}
/** Remove the file corresponding to the selected item */
void ProjectWid::slotRemoveFile()
{
	if ( currentListViewItem == 0 ) return ;

	project->removeFile ( currentListViewItem->text ( 0 ) ) ;
	delete   currentListViewItem   ;
	currentListViewItem  = 0 ;
}
/** Return the current project object (may be NULL) */
Project *ProjectWid::getProject()
{
	return project  ;
}
/** Make an empty popup menu with "title" header */
QMenu *ProjectWid::makePopup ( const QString& txt, QWidget *parent )
{	
        return  new QMenu(txt, parent) ;
}

QBEditor * ProjectWid::openEditor ( Q3ListViewItem *item )
{
        QBEditor *ed =  main_window->editor() ;

	QString file ( project->absFilename ( item->text ( 0 ) ) ) ;

        if ( ed   && (ed->switchOrLoad(QUrl(file))  == 0) )
	{
                QMessageBox::warning ( 0,tr ( "Sorry" ),
                                       tr ( "Cannot find file %1" ).arg ( file ) ,
		                       QMessageBox::Ok, Qt::NoButton, Qt::NoButton ) ;
                ed = 0 ;
	}
	return ed ;
}

/** No descriptions */
void ProjectWid::slotProjectElementClicked ( Q3ListViewItem *item )
{
        QBEditor *ed = 0 ;
	// click on the widget background calls this slot with a NULL pointer !
	if ( item == 0 ) return ;

	QString type ( item->text ( 2 ) ) ;
	// we only switch to source files
	if ( type == "A" || type == "C" || type == "I" ||
	        type == "H" || type == "R" || type == "S" )
	{
		ed = openEditor ( item ) ;
	}
	else if ( type == "RE"  || type == "CE" )
	{
		Q3ListViewItem *parent = item->parent() ;
		ed = openEditor ( parent ) ;
		// fetch line number
		int line =  item->text ( 3 ).toInt() ;
                // lines are internally numbered from zero, but displayed from 1
                if(ed) ed->slotFlashLine(line+1) ;
	}
	else
		QApplication::beep() ;
}
/** No descriptions */
void ProjectWid::slotInsertCurrentFile()
{
    QBEditorDocument *doc = main_window->editor()->currentDocument() ;
    if( doc == 0 ) return ;
        QString cur = doc->fileFullName() ;

	if ( FNU::isCSource ( cur ) || FNU::isAsmSource ( cur ) ||
	        FNU::isIncFile ( cur ) || FNU::isCHeader ( cur ) ||
	        FNU::isSrcLib ( cur ) )                     insertAbsFile ( cur ) ;
	else   QApplication::beep() ;
}
/** Invokes the Project Editor Widget */
void ProjectWid::slotEditProject()
{
	if ( project  && projecteditor == 0 )
	{
		if( configbits_editor ) configbits_editor->close(true) ;

		projecteditor = new ProjectEditorWid ( project,0,"project editor widget" ) ;
		connect ( projecteditor  , SIGNAL ( destroyed() ), this , SLOT ( slotProjectEditorClosed() ) ) ;
	}
}
/** No descriptions */
void ProjectWid::slotNewProject()
{

	if ( project != 0 || newproject != 0 ) return ;

	newproject = new NewProject;  // "new project"   widget
	connect ( newproject, SIGNAL ( projectData ( const QString&,const QString&, const QString& ) ),
	          this, SLOT ( slotCreateProject ( const QString&,const QString&, const QString& ) ) ) ;
	connect ( newproject  , SIGNAL ( destroyed() ), this , SLOT ( slotNewProjectClosed() ) ) ;

}
/** Updates the UI when a project is opened/closed */
void ProjectWid::slotProjectIsOpen ( bool open )
{
	// set up action validity
        main_window->act ( "new-project" )->setEnabled ( !open ) ;
        main_window->act ( "open-project" )->setEnabled ( !open ) ;
	if ( open )
        {
            RecentItemsAction *a =
            dynamic_cast< RecentItemsAction  *> (main_window->act("open-recent-project") ) ;
            if(a) a->addEntry(project->projectPathFileName());
	}
        main_window->act ( "open-recent-project" )->setEnabled ( !open ) ;

        main_window->act ( "close-project" )->setEnabled ( open ) ;
        main_window->act ( "edit-project" )->setEnabled ( open ) ;
        main_window->act ( "add-to-project" )->setEnabled ( open ) ;
        main_window->act ( "addcurrent-to-project" )->setEnabled ( open ) ;
}

/** No descriptions */
void ProjectWid::slotProjectEditorClosed()
{
	projecteditor = 0 ;
}
/** No descriptions */
void ProjectWid::slotOpenProjectFile ( const QString& projectfile )
{
	if ( projectfile == "" ) return ;

	if ( project ) slotCloseProject() ;

	project = new Project ( projectfile ) ;
	projectTree->setText ( 2,"P" ) ; // change status to "open project"
	projectTree->setText ( 0,projectfile ) ;

	if ( project->getType() == "asm" )
                projectTree->setText ( 1,tr ( "Asm project" ) ) ;
	else if ( project->getType() == "C" )
                projectTree->setText ( 1,tr ( "C project" ) ) ;
	else
		projectTree->setText ( 1,"" ) ;

	QStringList files = project->getFiles() ;
	for ( QStringList::iterator i = files.begin() ; i != files.end() ; ++i )
	{
		addFile2Tree ( *i ) ;
	}
	projectTree->setOpen ( true ) ;
	slotProjectIsOpen ( true ) ;
}
/** Drag and drop management
 */
void ProjectWid::dragEnterEvent ( QDragEnterEvent *ev )
{
	// accept if dragged object can be decoded as an URI
	ev->accept ( Q3UriDrag::canDecode ( ev ) ) ;


}
/** Drop on project widget */
void ProjectWid::dropEvent ( QDropEvent *ev )
{
	QStringList files ;
	if ( Q3UriDrag::decodeLocalFiles ( ev, files ) )
	{
		// only one file name, and it is a project file and no project already open
		if ( project == 0 && files.count() == 1 && FNU::isProjectFile ( * ( files.begin() ) ) )
		{
			// yes, open the project
			slotOpenProjectFile ( * ( files.begin() ) ) ;
		}
		else if ( project != 0 && files.count() == 1 && FNU::isProjectFile ( * ( files.begin() ) ) )
		{
			// close current project, and open a new one
			slotCloseProject() ;
			slotOpenProjectFile ( * ( files.begin() ) ) ;
		}
		else if ( project != 0 )
		{
			// try to include files in the current project
			for ( QStringList::Iterator it = files.begin(); it != files.end(); ++it )
			{
				if ( FNU::isAsmSource ( *it ) || FNU::isCSource ( *it ) || FNU::isLibFile ( *it )
				        ||  FNU::isObjFile ( *it ) || FNU::isIncFile ( *it ) ||
				        FNU::isSrcLib ( *it ) || FNU::isCHeader ( *it ) )
				{
					insertAbsFile ( *it ) ; // multiple insertions are checked by inserAbsFile()
				}
			}

		}
	}

}


/*!
    \fn ProjectWid::slotUpdateEntryPoints()
	This slot is typically  activated  from a timer
	but can be called anywhere else
 */
void ProjectWid::slotUpdateEntryPoints()
{
        if ( main_window->editor() )
	{
		for ( Q3ListViewItem * it = projectTree->firstChild();  it ; it = it->nextSibling() )
		{
			// get file name
			QString absfilename = project->absFilename ( it->text ( 0 ) ) ;

			if ( FNU::isSrcLib ( absfilename ) || FNU::isAsmSource ( absfilename ) )
			{
				// get editor pointer
                                QBEditorDocument *doc = main_window->editor()->document(QUrl(absfilename));
				// update tree
                                updateAsmEntryPoints ( doc, it ) ;

			}
			else if ( FNU::isCSource ( absfilename ) ||FNU::isCHeader ( absfilename ) )
			{
                                // get document  pointer
                                QBEditorDocument *doc = main_window->editor()->document(QUrl(absfilename));
				// update tree
                                updateCEntryPoints ( doc, it ) ;
			}
		}
	}
}


void ProjectWid::removeChildren ( Q3ListViewItem * it )
{
	Q3ListViewItem * it1 ;

	for ( it = it->firstChild() ; it ; )
	{
		it1 = it ;
		it = it->nextSibling() ;
		delete it1 ;
	}
}


/*!
    \fn ProjectWid::updateCEntryPoints(KBEditor *kb, QListViewItem *it)
 */


void ProjectWid::updateCEntryPoints ( QBEditorDocument *doc, Q3ListViewItem *it )
{
        if ( doc &&  !doc->analyzed() )
	{
		// try to analyze
		Parser p ;
                if ( p.parse ( doc ) == 0 )
		{
                        doc->setAnalyzed ( true ) ;

			if ( it->firstChild() != 0 )
				removeChildren ( it ) ;


			vector<SymbEntry>::iterator i ;
			for ( i = p.symbols().begin() ; i != p.symbols().end() ;  ++i )
			{
				int st = ( *i ).symbol_type ;
				QString sline = QString::number ( ( *i ).line ) ;
                                QString name = (( *i ).name).c_str()  ;
                                QString proto = (( *i ).prototype).c_str() ;
				const char **pix = 0 ;
				QString code ;


				if ( st & SymbEntry::Function )
				{
					pix =  st & SymbEntry::Definition ?
					       entrypointFctDef : entrypointFctDecl ;
					code = st & SymbEntry::Definition ? "F " : "f" ;

				}
				else if ( st & SymbEntry::Variable )
				{
					pix = st & SymbEntry::Definition ?
					      entrypointDataDef : entrypointDataDecl ;
					code = st & SymbEntry::Definition ?  "V" : "v" ;
				}
				else if ( st & SymbEntry::Typename )
				{
					pix = entrypointTypename ;
					code = "B" ;
				}
				XQListViewItem *entryItem =
				    new XQListViewItem ( it,name, proto ,"CE" , sline, code ) ;


				entryItem->setPixmap ( 0, QPixmap ( pix ) ) ;
			}
		}
		else
		{
			// QApplication::beep() ;
			// cout << "Parse error" << endl ;
			// cout << p.getErrMessage() << endl ;
		}

	}

}


/*!
    \fn ProjectWid::updateAsmEntryPoints(KBEditor *ed, QListViewItem *it)
 */
void ProjectWid::updateAsmEntryPoints ( QBEditorDocument *doc   , Q3ListViewItem *it )
{
        if ( doc &&  !doc->analyzed() )
	{
		if ( it->firstChild() != 0 )
		{
			// remove entry points items
			removeChildren ( it ) ;
		}
		CodeAnalyzer ca  ;
                ca.analyze ( doc ) ;
		vector<EntryPointRecord>& ep = ca.entryPoints() ;
		for ( unsigned int i = 0 ; i < ep.size()  ; ++i )
		{
			QString sline = QString::number ( ep[i].line ) ;
			QString name = ep[i].name ;
			const char **pix = 0 ;
			QString prototype = ep[i].prototype  ;
			pix = entrypointA_slb ;

			XQListViewItem *entryItem =
			    new XQListViewItem ( it,name, prototype, "RE",sline , "" ) ;
			entryItem->setPixmap ( 0, QPixmap ( pix ) ) ;
		}
                doc->setAnalyzed ( true ) ;
	}

}


/*!
    \fn ProjectWid::slotEditConfigBits()
 */
void ProjectWid::slotEditConfigBits()
{
	if ( project == 0 )
		return ; // Mmmmm

	QString device = project->getDevice() ;
	if (   pikDB::pikdb()->getData ( device )  == 0 )
	{
                QMessageBox::warning ( 0,tr ( "Sorry" ),
                                       tr ( "%1 : unknown device." ).arg ( device ),
		                       QMessageBox::Ok, Qt::NoButton, Qt::NoButton ) ;
		return ;
	}

	if ( configbits_editor != 0 ) configbits_editor->close ( true ) ;
	// since project editor allows to change the device at any moment
	// I close it to preserve consistancy
	if ( projecteditor != 0 ) projecteditor->close ( true ) ;

	configbits_editor = new ConfigBitsWizard ( 0 ) ;
	connect(configbits_editor, SIGNAL(closed()), this, SLOT(slotConfigBitsEditorClosed())) ; 
}

PikMain *ProjectWid::mainWindow()
{
	return main_window ;
}


/*!
    \fn ProjectWid::slotConfigBitsEditorClosed()
 */
void ProjectWid::slotConfigBitsEditorClosed()
{
    configbits_editor = 0 ;
}
