#include "Appli.h"
#include "QBEditor.h"
#include "ItemSelector.h"
#include <QtGui>

#include <iostream>
using namespace std ;

Appli::Appli() : QMainWindow(0)
{
    edit=new QBEditor(this) ;
    setCentralWidget(edit) ;

    QMenu *menuFile=new QMenu("File") ;
    menuBar()->addMenu(menuFile) ;

    QMenu *menuEdit=new QMenu("Edit") ;
    menuBar()->addMenu(menuEdit) ;

    QMenu *dynamicBookmarks = new QMenu("Bookmarks") ;
    menuBar()->addMenu(dynamicBookmarks) ;

    QMenu *menuDevel=new QMenu("Development") ;
    menuBar()->addMenu(menuDevel) ;
    QAction *experiment = new QAction("Dialog",this) ;
    menuDevel->addAction(experiment) ;
    connect(experiment,SIGNAL(triggered()), this , SLOT(slotExperiment())) ;

/*
    QAction *actFlash = new QAction("&Flash" , this ) ;
    connect(actFlash, SIGNAL(activated()), edit, SLOT(slotFlashCurrentLine()) );
*/

   QAction *quit = new QAction(QIcon(), tr("&Quit"), this) ;


    menuFile->addAction(edit->act("new")) ;
    menuFile->addAction(edit->act("open")) ;
    menuFile->addAction(edit->act("save")) ;
    menuFile->addAction(edit->act("save-as")) ;
    menuFile->addAction(edit->act("close")) ;
    menuFile->addAction(quit) ;


    menuEdit->addAction(edit->act("undo")) ;
    menuEdit->addAction(edit->act("redo")) ;
    menuEdit->addAction(edit->act("cut")) ;
    menuEdit->addAction(edit->act("copy")) ;
    menuEdit->addAction(edit->act("paste")) ;

    menuEdit->addAction(edit->act("search-replace")) ;
    menuEdit->addAction(edit->act("goto")) ;

    menuEdit->addSeparator() ;
    menuEdit->addAction(edit->act("line-numbers")) ;
    menuEdit->addAction(edit->act("bookmarks")) ;

    menuEdit->addSeparator() ;
    menuEdit->addAction(edit->act("comment")) ;
    menuEdit->addAction(edit->act("uncomment")) ;


    connect(dynamicBookmarks,SIGNAL(aboutToShow()), edit, SLOT(slotShowBookmarksMenu())) ;
    connect(quit, SIGNAL(activated()), this, SLOT(slotQuit()) ) ;


   //  menuDevel->addAction(actFlash) ; // test purpose only
    setMinimumSize(QSize(640,480)) ;


}

void Appli::slotQuit()
{
    edit->slotAboutToClose() ;
    qApp->quit();
}
void Appli::slotExperiment()
{
    /*
    ItemSelector sel("The following files are not saved.", this) ;
    sel.addItem("toto", 0);
    sel.addItem("titi", 1);
    sel.addItem("burp", 2);
    sel.addItem("gasp", 3);
    sel.addItem("hein ??", 4);
    sel.addItem("fdsf", 40);
    sel.addItem("fsdf ??", 41);
    sel.addItem("gfghfg ??", 42);
    sel.addItem("ghfgh ??", 43);
    sel.addItem("hfgh ??", 44);
    sel.exec() ;

    int res = sel.result() ;
    if( res == ItemSelector::Cancel )
        cout << "Cancel .. " << endl ;
    QVector<int> r = sel.results() ;
    for(int i = 0 ; i < r.count() ; ++i)
        cout << r[i] << endl ;

*/
}
